﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading;
using System.Windows.Forms;
using System.Concurrency;
using Microsoft.DevLabs.Reactive.Bridge.Instrumentation;

namespace ValtechTechDays2011
{
    class Program
    {
        static void Main(string[] args)
        {


            // Example 1.a
            var list = new List<int>() { 1, 2, 3, 4, 5, 6 };

            foreach (var item in list)
            {
                Console.WriteLine(item);
            }
            Console.WriteLine("---");

            //Example 1.b
            var enumerator = list.GetEnumerator();
            while (enumerator.MoveNext()) // MoveNext return true, false or throws an Exception...
            {
                Console.WriteLine(enumerator.Current);
            }
            Console.WriteLine("---");


            //// Example 2
            //var sequence = new FunkyEnumerable(i => i * 10);
            //foreach (var item in sequence)
            //{
            //    Console.WriteLine(item);
            //    Console.WriteLine("Waiting...");
            //}


            //// Example 3
            //var sequence =
            //    new FunkyEnumerable(i => i * i)
            //    .ToObservable(Scheduler.TaskPool)
            //    .Subscribe(str => Console.WriteLine(str));

            //Console.WriteLine("Working with other stuff..");
            //while (true)
            //{
            //    Console.Write(".");
            //    Thread.Sleep(10);
            //}


            //// Example 4
            //var evenNumbers = from t in new FunkyEnumerable(i => 100)
            //                      .ToObservable(Scheduler.TaskPool)
            //                  where int.Parse(t) % 2 == 0
            //                  select t;

            //var oddNumbers = from t in new FunkyEnumerable(i => 200)
            //                     .ToObservable(Scheduler.TaskPool)
            //                 where int.Parse(t) % 2 != 0
            //                 select t;

            //using (evenNumbers.Subscribe(str => Console.WriteLine(str + " - even")))
            //using (oddNumbers.Subscribe(str => Console.WriteLine(str + " - odd")))
            //{
            //    Console.WriteLine("Press Enter to stop...");
            //    Console.ReadLine();
            //}


            //// Exempel 5
            //var txt = new TextBox();
            //var frm = new Form
            //{
            //    Controls = { txt }
            //};

            //var moves = from evt in Observable.FromEvent<MouseEventArgs>(frm, "MouseMove")
            //            where txt.Text.ToUpper() == "ON"
            //            select evt.EventArgs.Location.ToString();
            //var input = from evt in Observable.FromEvent<EventArgs>(txt, "TextChanged")
            //            select txt.Text;
            //var quit = from evt in Observable.FromEvent<EventArgs>(txt, "TextChanged")
            //           where txt.Text.ToUpper() == "QUIT"
            //           select txt.Text;

            //using (moves.Subscribe(Console.WriteLine))
            //using (input.Subscribe(Console.WriteLine))
            //using (quit.Subscribe(_ => frm.Close()))
            //{
            //    Application.Run(frm);
            //}
            //Console.WriteLine("Done!");


            //// Exempel 6
            //var txt = new TextBox { Text = "On" };
            //var frm = new Form
            //{
            //    Controls = { txt }
            //};

            //var moves = from evt in Observable.FromEvent<MouseEventArgs>(frm, "MouseMove")
            //                .Sample(TimeSpan.FromSeconds(1))
            //            where txt.Text.ToUpper() == "ON"
            //            select evt.EventArgs.Location.ToString();
            //var input = from evt in Observable.FromEvent<EventArgs>(txt, "TextChanged")
            //                .Delay(TimeSpan.FromSeconds(3))
            //                .DistinctUntilChanged(e => txt.Text)
            //            select txt.Text;
            //var quit = from evt in Observable.FromEvent<EventArgs>(txt, "TextChanged")
            //               .Throttle(TimeSpan.FromSeconds(2))
            //           where txt.Text.ToUpper() == "QUIT"
            //           select txt.Text;

            //using (moves.Subscribe(Console.WriteLine))
            //using (input.Subscribe(Console.WriteLine))
            //using (quit.Subscribe(_ => frm.Close()))
            //{
            //    Application.Run(frm);
            //}
            //Console.WriteLine("Done!");


            //// Example 7
            //var processesStart = (from proc in EventProvider.Qbserve<ProcessStartTrace>()
            //                      where proc.ProcessName == "Notepad2.exe"
            //                      select proc)
            //    .AsObservable().Timestamp();
            //var processesStop = (from proc in EventProvider.Qbserve<ProcessStopTrace>()
            //                     where proc.ProcessName == "Notepad2.exe"
            //                     select proc)
            //    .AsObservable().Timestamp();

            //using (processesStart.Subscribe(p => Console.WriteLine("Started: {0} ({1}) - {2}", p.Value.ProcessName, p.Value.ProcessID, p.Timestamp)))
            //using (processesStop.Subscribe(p => Console.WriteLine("Stopped: {0} ({1}) - {2}", p.Value.ProcessName, p.Value.ProcessID, p.Timestamp)))
            //{
            //    Console.WriteLine("Press Enter to stop...");
            //    Console.ReadLine();
            //}
            //Console.WriteLine("Done!");


            //// Exempel 8
            //var loremSvc = new LoremService.LoremClient();

            //var svc1 = from text in Observable.FromAsyncPattern<string>(loremSvc.BeginGetLorem, loremSvc.EndGetLorem)()
            //           select "Svc1: \n" + text + "\n";
            //var svc2 = from text in Observable.FromAsyncPattern<string>(loremSvc.BeginGetLorem, loremSvc.EndGetLorem)()
            //           select "Svc2: \n" + text + "\n";
            //var svc3 = from text in Observable.FromAsyncPattern<string>(loremSvc.BeginGetLorem, loremSvc.EndGetLorem)()
            //           select "Svc3: \n" + text + "\n";

            //var services = new List<IObservable<string>>() { svc1, svc2, svc3 };

            ////using (svc1.Subscribe(Console.WriteLine))
            ////using (svc2.Subscribe(Console.WriteLine))
            ////using (svc3.Subscribe(Console.WriteLine))
            //using (services.Amb().Subscribe(Console.WriteLine))
            //{
            //    Console.WriteLine("Press Enter to stop...");
            //    Console.ReadLine();
            //}
            //Console.WriteLine("Done!");



          







        }

    }














    
    class FunkyEnumerable : IEnumerable<string>
    {
        private Func<int,int> _delayFunction;

        public FunkyEnumerable(Func<int, int> delayFunction)
        {
            _delayFunction = delayFunction;
        }
        public IEnumerator<string> GetEnumerator()
        {
            return new FunkyEnumerator(_delayFunction);
        }

        IEnumerator IEnumerable.GetEnumerator()
        {
            return GetEnumerator();
        }

    }

    class SecondsTicker : IEnumerable<string>
    {
        private int _intervall;

        public SecondsTicker(int intervall)
        {
            _intervall = intervall;
        }
        public IEnumerator<string> GetEnumerator()
        {
            return new TickerEnumerator(_intervall);
        }

        IEnumerator IEnumerable.GetEnumerator()
        {
            return GetEnumerator();
        }
    }

    class FunkyEnumerator: IEnumerator<string>
    {
        int _current;
        Func<int,int> _delayTimeFunktion;

        public FunkyEnumerator(Func<int,int> delayFunction)
        {
            _delayTimeFunktion = delayFunction;
        }
        #region IEnumerator<string> Members

        public string Current
        {
            get { return _current.ToString() ; }
        }

        #endregion

        #region IDisposable Members

        public void Dispose()
        {
            // No op...
            //throw new NotImplementedException();
        }

        #endregion

        #region IEnumerator Members

        object IEnumerator.Current
        {
            get { return _current.ToString(); }
        }

        public bool MoveNext()
        {
            var delay = _delayTimeFunktion.Invoke(_current);
            Thread.Sleep(delay);
            _current++;
            return true;
        }

        public void Reset()
        {
            throw new NotImplementedException();
        }

        #endregion
    }
    class TickerEnumerator : IEnumerator<string>
    {
        private DateTime _latest;
        private int _intervall;

        public TickerEnumerator(int intervall)
        {
            _intervall = intervall;
        }
        public void Dispose()
        {
            //throw new NotImplementedException();
        }

        public bool MoveNext()
        {
            //Never ends...
            return true; 
        }

        public void Reset()
        {
            //throw new NotImplementedException();
            // No op...
        }

        public string Current
        {
            get
            {
                while ((DateTime.Now - _latest < TimeSpan.FromSeconds(_intervall)) || (DateTime.Now.Second % _intervall != 0))
                {
                    Thread.Sleep(100);
                }
                _latest = DateTime.Now;
                return _latest.ToString("hh:mm:ss");
            }
        }

        object IEnumerator.Current
        {
            get { return Current; }
        }
    }


    [WmiEventClass("Win32_ProcessStartTrace")]
    class ProcessStartTrace
    {
        public uint ProcessID { get; set; }
        public string ProcessName { get; set; }
    }

    [WmiEventClass("Win32_ProcessStopTrace")]
    class ProcessStopTrace
    {
        public uint ProcessID { get; set; }
        public string ProcessName { get; set; }
    }


}
